#define LEDnum 5
const byte LEDpin[LEDnum] = {13, 12, 11, 10, 9};
const byte BUTTONpin = 2;
byte letturaPrecedente;
// statoLED è usato come un vettore di bit
byte statoLED = 0;

void setup() {
  for (byte c=0; c < LEDnum; c++)
    pinMode(LEDpin[c], OUTPUT);
    
  pinMode(BUTTONpin, INPUT);
  
  letturaPrecedente = digitalRead(BUTTONpin);
}

void loop() {
  byte letturaAttuale = digitalRead(BUTTONpin);
  
  if (letturaAttuale == HIGH && letturaPrecedente == LOW) {
    for (byte c = 0; c < LEDnum; c++) {
      // Operazione di mascheramento
      byte statoLEDattuale = statoLED & _BV(c);
      digitalWrite(LEDpin[c], statoLEDattuale);
    }
    statoLED++;
    if (statoLED >= _BV(LEDnum))
      statoLED = 0;
    letturaPrecedente = HIGH;
  }
  else if(letturaAttuale == LOW && letturaPrecedente == HIGH) {
    letturaPrecedente = LOW;
  }
  
  delay(50);
}
